using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.IO;
using System.Text;
using System.Xml;

namespace PPCUpdaterWebService
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Updater : System.Web.Services.WebService
	{
		public Updater()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		/// <summary>
		/// Returns an xml file with a list of current files and current versions
		/// </summary>
		/// <param name="DeviceID"></param>
		/// <returns></returns>
		[WebMethod]
		public string GetFileInventory()
		{
			//get the path from where to get the files from, from the web.config file
			string FilePath = System.Configuration.ConfigurationSettings.AppSettings["AppFilesPath"];

            XmlDocument xDoc = new XmlDocument();
			xDoc.Load(Path.Combine(FilePath,"Deployment.Xml"));
            System.Xml.XmlAttribute xa; 

			foreach(XmlNode n in xDoc.DocumentElement.ChildNodes)
			{
                //get the lastwrite time from the actual file, and assign 
                //that value to the xml before sending the xml out to the consumer
                FileInfo fi = new FileInfo(Path.Combine(FilePath,n.Attributes.GetNamedItem("name").Value));
                
                //create a date attribute and assign the current timestamp to this attribute
                xa = xDoc.CreateAttribute("date");
                xa.Value = fi.LastWriteTime.ToString();
                n.Attributes.Append(xa);
            }

			return xDoc.InnerXml;
		}

	    /// <summary>
	    /// Return an xml string with base64 encoded binary files
	    /// </summary>
	    /// <param name="FileListXml">A list of files to be encoded and returned</param>
		[WebMethod]
		public string GetBinaries(string FileListXml)
		{
			XmlDocument xDoc = new XmlDocument();
			xDoc.LoadXml(FileListXml);
			System.Xml.XmlAttribute xa; 
			
			foreach(XmlNode n in xDoc.DocumentElement.ChildNodes)
			{
				xa = xDoc.CreateAttribute("value");
				xa.Value = GetBase64StringFromFile(n.Attributes.GetNamedItem("name").Value);
				//add the base64string to the node
				n.Attributes.Append(xa);
			}

			//send back the document as we received it, with the addition of the base64 binary strings
			return xDoc.InnerXml;
		}

	    /// <summary>
	    /// Return a base64 string give a full file path
	    /// </summary>
	    /// <param name="file">valid full file path</param>
	    /// <returns>Base64 encoded binary string</returns>
		private string GetBase64StringFromFile(string file)
		{
            //Open the file, and load it into the FileStream
            FileStream inFile = new FileStream(file,FileMode.Open,FileAccess.Read,FileShare.Read);
			byte[] binaryData = new Byte[inFile.Length];
			long bytesRead = inFile.Read(binaryData, 0,(int)inFile.Length);
			inFile.Close();

            //Convert the byte array to a base64 string
			return System.Convert.ToBase64String(binaryData,0,binaryData.Length);
		}

	
	}
}
